/*Simple XiscoSoft Ciffering Utility v0.1 alpha*/

/*The object of this program is pretty simple it will cypher the input file to
the output file using XOR with a given password. Although with mode 2 will use
Xnor and modes 3 and 4 are not fully multisystem capable and will use a seed
generated using the given password in a future it will be possible using a file
to provide the password*/

#include <stdio.h>
#include <stdlib.h>

/*1kb should be enough for the lenght of a path*/
#define MAXPATHLENGHT 1024

/*This defines the total number of encryption algorithm we have*/
#define TYPEMAX 2


/*1kb should be enoguh for a password*/
#define MAXPASSLENGHT 1024

/*Function headers*/
unsigned int gen_seed(unsigned char *password);
int std_cypher(char *input, char *output, char *password, int passisfile , int mode);
void help(int error);

/*The main function*/
/*Return codes:
              ·-1 Incorrect or insuficient parameters
              · 0 All gone OK
              · 1 Failure with input file
              · 2 Failure with output file
              · 3 Failure with password file
*/
int main(int argc, char **argv) {
    int i,j;
 
    /*Flags declaration*/
    int type, passinfile, decinput, decoutput, decpass, dechelp, currarg, dectype;
    char *input; /*NULL means stdin*/
    char *output; /*NULL means stdout*/
    char *password; /*That it points to NULL is really bad, it will hang up and
                      fire will go out from the eternal deepness, before that
                      I'll call your parents and tell them what you use internet
                      for, and will kill you slowly and painfully in such a way
                      you'll think the inferno is good*/
    
    /*Initializations*/
    type = 1;
    passinfile = 0;
    decinput = 0;
    decoutput = 0;
    decpass = 0;
    dechelp = 0;
    currarg = 0;
    dectype = 0;
    input = NULL;
    output = NULL;
    password = NULL;

    /*Input parameters parsing*/
    /*Remember: the input parameters should be:
      progname inputfile outputfile password
      using the following parameters:
           -i inputfilepath
           -o outputfilepath
           -p password
           -P passfilepath
           -t encriptiontype
           -m same as -t
           -h help
       Please note that if you want to use a file for the password you have to use -P
       That -p and  -P are mutally excluyent
       That -t should be followed by an unsigned integer 
    */
    #define callhelp(a) help(a); return -1
    if (argc >= 2)
        for (i = 1; i <= argc - 1; i++) {
            if (*(argv[i]) != '-')
            /*Read the standard arguments*/
                switch (currarg) {
                    case 0:
                        if (decinput == 0) {
                            input = argv[i];
                            currarg++;
                            decinput = 1;}
                        else callhelp(1);
                        break;
                    case 1:
                        if (decoutput == 0) {
                            output = argv[i];
                            currarg++;
                            decoutput = 1;}
                        else callhelp(1);
                        break;
                    case 2:
                        if (decpass == 0) {
                            password = argv[i];
                            currarg++;
                            decpass = 1;}
                        else callhelp(1);
                        break;
                    default: callhelp(2);
                }
            else
            /*Switch between the diferent posible arguments*/
                switch ((argv[i])[1]) {
                    case '\0':
                        currarg++;
                        break;
                    case 'h':
                        callhelp(0);
                        break;
                    case 'i':
                        if(decinput == 0) {
                            input = argv[++i];
                            decinput = 1;
                        } else 
                            callhelp(2);
                        break;
                    case 'o':
                        if(decoutput == 0) {
                            output = argv[++i];
                            decoutput = 1;
                        } else
                            callhelp(2);
                        break;
                    case 'P':
                        passinfile = 1;
                    case 'p':
                        if(decpass == 0) {
                            password = argv[++i];
                            decpass = 1;
                        } else
                            callhelp(2);
                        break;
                    case 'm':
                    case 't':
                        if(dectype == 0) {
                            i++;
                            for(j=0; (argv[i])[j]!='\0'; j++)
                                if(((argv[i])[j] < '0')||((argv[i])[j] > '9'))
                                    callhelp(3);
                            type = atoi(argv[i]);
                            if((type < 1)||(type > TYPEMAX))
                                callhelp(4);
                            dectype = 1;
                        } else
                            callhelp(2);
                        break;
                    default: callhelp(5);
                }
        }
/*This line should be removed in a future*/
if (password == NULL) callhelp(5);
    std_cypher(input, output, password, passinfile, type);
    return 0;
}

/*Callhelp notes:
Use stderr;
0 is the standar help call
1 means Duplicated Parameters
2 means Excesive parameters
3 means type is not followed by an integer
4 means incorrect type
5 means undefined option
*/
void help(int error) {
#ifndef stdhelp1
    #define stdhelp1 "Uso: sxscu [args] [inputfile] [args] [outputfile] [args] [password] [args]\n\
Todos los parámetros son opcionales, pero debe definirse al menos la contraseña\n\
inputfile y outputfile son la ruta al fichero de entrada y al de salida respectivamente, si se usan guiones, se entenderá que se quiere usar la entrada o la salida estándar respectivamente\n\
password es la contraseña de codificación/decodificación\n"
#endif
#ifndef stdhelp2
#define stdhelp2 "Puedes usar los siguientes parámetros:\n\
    -i Ruta al fichero de entrada\n\
    -o Ruta al fichero de salida\n\
    -p Contraseña\n\
    -P Ruta al fichero con la contraseña\n\
    -t Tipo de encriptación (1=XOR, 2=XNOR)\n\
    -m Equivale a -t\n\
    -h Ayuda\n"
#endif
#ifndef stdhelp3
#define stdhelp3 "Por favor ten en cuenta que:\n\
    ·La única forma de que el programa sepa que la contraseña está en un fichero es usando el parámetro -P\n\
    ·-p y -P son mutuamente excluyentes\n\
    ·-t debe ser seguido por un entero sin signo\n"
#endif

#ifndef error0
    #define error0 "Sólo aquellos que pidieron ayuda realmente la obtuvieron:\n"
#endif

#ifndef error1
    #define error1 "El fuego eterno caerá de los cielos sobre aquellos que hayan sido tan impruedentes como para intentar hacerme adivinar cual de las dos opciones que ha repetido es la que realmente quiere que use."
#endif
#ifndef error2
    #define error2 "Tras el sonido de las campanas los jinetes mugrientos y bien armados perseguirán hasta la muerte a aquellos que me den más parámetros de los que realmente puedo entender."
#endif
#ifndef error3
    #define error3 "Tras un gran estruendo la progenie de aquellos que no me pasen como tipo de encriptación un entero sin signo serán asesinados haciendo que sus padres mueran llorando la muerte de los suyos."
#endif
#ifndef error4
    #define error4 "Una gran inundación de azufre ardiente afligió a aquellos que intentaron usar un tipo de encriptación que aún no había sido implementado"
#endif
#ifndef error5
    #define error5 "Los secretos de todos aquellos que no usaron una contraseña fueron puestos al descubierto haciendo que se suicidaran al no poder soportar los ojos acusadores de los demás habitantes"
#endif
#ifndef errorwarn
    #define errorwarn "Tú eres idiota ¿o qué? Acaso crees que tengo poderes de adivinación para saber que coño quieres, saber se que ni te has molestado en usar la pedazo ayuda de que dispongo. Mira a ver por que coño:\n%s\n\n En fin, mira la ayuda de una vez a ver si aprendes algo útil:\n"
#endif
#define printhelp fprintf(stderr,"%s%s%s", stdhelp1, stdhelp2, stdhelp3); break
switch(error) {
    case 0:
        fprintf(stderr, error0);
        printhelp;
    case 1:
        fprintf(stderr, errorwarn, error1);
        printhelp;
    case 2:
        fprintf(stderr, errorwarn, error2);
        printhelp;
    case 3:
        fprintf(stderr, errorwarn, error3);
        printhelp;
    case 4:
        fprintf(stderr, errorwarn, error4);
        printhelp;
    case 5:
        fprintf(stderr, errorwarn, error5);
        printhelp;
}
#undef printhelp
}

/*This will make the random seed for modes 3 and 4 The object is avoiding the
password discovery althought they may have decyphered the file*/

unsigned int gen_seed(unsigned char *password) {
    int sum=0;

    while (*password != '\0') {
        sum += *password;
        password++;
        }

    return sum;
}

/*Cyphering and core function of the program*/

int std_cypher(char *input, char *output, char *password, int passisfile , int mode) {
    FILE *in, *out, *pass;
    char temp = 'a', *tempas = password;
    int cont = 1;

    /*First we open the necessary files if needed*/
    if (input != NULL) {
        in = fopen (input, "rb");
        if (in == NULL) return 1;
    } else
        in = stdin;

    if (output != NULL) {
        out = fopen (output, "wb");
        if (out == NULL) {fclose(in); return 2;}
    } else
        out = stdout;

    if (passisfile == 1) {
        pass = fopen (password, "rb");
        if (pass == NULL) {fclose(in); fclose(out); return 3;}
    }

    /*Althought it may mean more code lines we'll make a while for each method*/
    #define stdwhile while (cont && !feof(in))
    #define stdwhilein temp = getc(in);\
                       if(feof(pass)) {\
                          rewind(pass);\
                          if (feof(pass)) return 3;};\
                       *tempas = getc(pass);
    if (passisfile)
        switch(mode) {
            case 1:
                stdwhile {
                    stdwhilein;
                    if (putc(temp ^ *tempas, out) == EOF) return 2; 
                    }
                break;
            case 2:
                stdwhile {
                    stdwhilein;
                    if (putc(~(temp ^ *tempas), out) == EOF) return 2; 
                    }
                break;
        /*For now modes 3 and 4 won't work*/
            case 3:
                break;
            case 4:
                break;
        }
    #undef stdwhile
    #undef stdwhilein
    #define stdwhile while (cont && !feof(in))
    #define stdwhilein temp = getc(in);\
                       if(*tempas == '\0') \
                          tempas = password;

        else switch(mode) {
            case 1:
                stdwhile {
                    stdwhilein;
                    if (putc(temp ^ *tempas, out) == EOF) return 2;
                    tempas++;
                }
                break;
            case 2:
                stdwhile {
                    stdwhilein;
                    if (~putc((temp ^ *tempas), out) == EOF) return 2;
                    tempas++;
                }
                break;
        /*For now modes 3 and 4 won't work*/
            case 3:
                break;
            case 4:
                break;
        }
    #undef stdwhile
    #undef stdwhilein


    /*Cerramos ficheros varios*/
    if (passisfile) fclose(pass);
    if (in != stdin) fclose(in);
    if (out != stdout) fclose(out);
    return 0;
}


